<?php
/** 
Plugin Name: MultiLive - Multiple Live Stream Broadcaster
Plugin URI: //1.envato.market/coderevolution
Description: This plugin will automatically upload videos embedded in your published post's content to multiple live streams at once!
Author: 20script
Version: 1.1.1.2
Author URI: https://www.20script.ir
License: Commercial. For personal use only. Not to give away or resell.
Text Domain: multilive-multiple-live-stream-broadcaster
*/
/*  
Copyright 2016 - 2023 CodeRevolution
*/
defined('ABSPATH') or die();
require_once (dirname(__FILE__) . "/res/other/plugin-dash.php"); 


function multilive_load_textdomain() {
    load_plugin_textdomain( 'multilive-multiple-live-stream-broadcaster', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
}
add_action( 'init', 'multilive_load_textdomain' );


$plugin = plugin_basename(__FILE__);
if(is_admin())
{
    $plugin_slug = explode('/', $plugin);
    $plugin_slug = $plugin_slug[0];
    if(isset($_POST[$plugin_slug . '_register']) && isset($_POST[$plugin_slug. '_register_code']) && trim($_POST[$plugin_slug . '_register_code']) != '')
    {
        $uoptions = array();
        $uoptions['item_id'] = 24121974;
        $uoptions['item_uid'] = 'pqwl9-he9jk-p6t92-c8sdu-og987-rqidc-egybg';
        $uoptions['code'] = $_POST[$plugin_slug . '_register_code'];
        $uoptions['item_name'] = 'MultiLive - Multiple Live Stream Broadcaster';
        $uoptions['created_at'] = '24.12.1974';
        $uoptions['buyer'] = 'Tom & Jerry';
        $uoptions['licence'] = 'extended';
        $uoptions['supported_until'] = '24.12.2038';
        update_option($plugin_slug . '_registration', $uoptions);
        update_option('coderevolution_settings_changed', 2);
    }
    require "update-checker/plugin-update-checker.php";
    $fwdu3dcarPUC = YahnisElsts\PluginUpdateChecker\v5\PucFactory::buildUpdateChecker("https://wpinitiate.com/auto-update/?action=get_metadata&slug=multilive-multiple-live-stream-broadcaster", __FILE__, "multilive-multiple-live-stream-broadcaster");
    add_filter("plugin_action_links_$plugin", 'mlsb_add_settings_link');
    add_filter("plugin_action_links_$plugin", 'mlsb__add_rating_link');
    add_filter("plugin_action_links_$plugin", 'mlsb_add_support_link');
    add_action('admin_menu', 'mlsb_register_my_custom_menu_page');
    add_action('network_admin_menu', 'mlsb_register_my_custom_menu_page');
    add_filter('autosave_interval', 'mlsb_filter_autosave_interval');
    add_action('admin_init', 'mlsb_register_mysettings');
    require(dirname(__FILE__) . "/res/mlsb-main.php");
    require(dirname(__FILE__) . "/res/mlsb-multi-list.php");
    require(dirname(__FILE__) . "/res/mlsb-logs.php");
}
function mlsb_admin_enqueue_all()
{
    $reg_css_code = '.cr_auto_update{background-color:#fff8e5;margin:5px 20px 15px 20px;border-left:4px solid #fff;padding:12px 12px 12px 12px !important;border-left-color:#ffb900;}';
    wp_register_style( 'mlsb-plugin-reg-style', false );
    wp_enqueue_style( 'mlsb-plugin-reg-style' );
    wp_add_inline_style( 'mlsb-plugin-reg-style', $reg_css_code );
}
function mlsb_add_activation_link($links)
{
    $settings_link = '<a href="admin.php?page=mlsb_admin_settings">' . esc_html__('Activate Plugin License', 'multilive-multiple-live-stream-broadcaster') . '</a>';
    array_push($links, $settings_link);
    return $links;
}

function mlsb_register_my_custom_menu_page()
{
    add_menu_page('MultiLive - Live Stream Broadcaster', 'MultiLive - Live Stream Broadcaster', 'manage_options', 'mlsb_admin_settings', 'mlsb_admin_settings', plugins_url('images/icon.png', __FILE__));
    $main = add_submenu_page('mlsb_admin_settings', esc_html__("Main Settings", 'multilive-multiple-live-stream-broadcaster'), esc_html__("Main Settings", 'multilive-multiple-live-stream-broadcaster'), 'manage_options', 'mlsb_admin_settings');
    add_action( 'load-' . $main, 'mlsb_load_all_admin_js' );
    add_action( 'load-' . $main, 'mlsb_load_main_admin_js' );
    $mlsb_Main_Settings = get_option('mlsb_Main_Settings', false);
    if (isset($mlsb_Main_Settings['mlsb_enabled']) && $mlsb_Main_Settings['mlsb_enabled'] == 'on') {
        $multi = add_submenu_page('mlsb_admin_settings', esc_html__('Multi-Stream Now', 'multilive-multiple-live-stream-broadcaster'), esc_html__('Multi-Stream Now', 'multilive-multiple-live-stream-broadcaster'), 'manage_options', 'mlsb_multi_panel', 'mlsb_multi_panel');
        add_action( 'load-' . $multi, 'mlsb_load_post_admin_js' );
        add_action( 'load-' . $multi, 'mlsb_load_all_admin_js' );
        $logs = add_submenu_page('mlsb_admin_settings', esc_html__("Activity & Logging", 'multilive-multiple-live-stream-broadcaster'), esc_html__("Activity & Logging", 'multilive-multiple-live-stream-broadcaster'), 'manage_options', 'mlsb_logs', 'mlsb_logs');
        add_action( 'load-' . $logs, 'mlsb_load_all_admin_js' );
    }
}
function mlsb_load_post_admin_js(){
    add_action('admin_enqueue_scripts', 'mlsb_admin_load_post_files');
}

function mlsb_admin_load_post_files()
{
    wp_register_script('mlsb-submitter-script', plugins_url('scripts/poster.js', __FILE__), false, '1.0.0');
    wp_enqueue_script('mlsb-submitter-script');
}
function mlsb_load_main_admin_js(){
    add_action('admin_enqueue_scripts', 'mlsb_enqueue_main_admin_js');
}

function mlsb_enqueue_main_admin_js(){
    wp_enqueue_script('multilive-main-script', plugins_url('scripts/main.js', __FILE__), array('jquery'));
}
function mlsb_load_all_admin_js(){
    add_action('admin_enqueue_scripts', 'mlsb_admin_load_files');
}
function mlsb__add_rating_link($links)
{
    $settings_link = '<a href="//codecanyon.net/downloads" target="_blank" title="Rate">
            <i class="wdi-rate-stars"><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg><svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" viewBox="0 0 24 24" fill="#ffb900" stroke="#ffb900" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-star"><polygon points="12 2 15.09 8.26 22 9.27 17 14.14 18.18 21.02 12 17.77 5.82 21.02 7 14.14 2 9.27 8.91 8.26 12 2"></polygon></svg></i></a>';
    array_push($links, $settings_link);
    return $links;
}

function mlsb_add_support_link($links)
{
    $settings_link = '<a href="//coderevolution.ro/knowledge-base/" target="_blank">' . esc_html__('Support', 'multilive-multiple-live-stream-broadcaster') . '</a>';
    array_push($links, $settings_link);
    return $links;
}

function mlsb_add_settings_link($links)
{
    $settings_link = '<a href="admin.php?page=mlsb_admin_settings">' . esc_html__('Settings', 'multilive-multiple-live-stream-broadcaster') . '</a>';
    array_push($links, $settings_link);
    return $links;
}

add_filter('cron_schedules', 'mlsb_add_cron_schedule');
function mlsb_add_cron_schedule($schedules)
{
    $schedules['mlsb_cron'] = array(
        'interval' => 3600,
        'display' => esc_html__('mlsb Cron', 'multilive-multiple-live-stream-broadcaster')
    );
    $schedules['minutely'] = array(
        'interval' => 60,
        'display' => esc_html__('Once A Minute', 'multilive-multiple-live-stream-broadcaster')
    );
    $schedules['weekly']        = array(
        'interval' => 604800,
        'display' => esc_html__('Once Weekly', 'multilive-multiple-live-stream-broadcaster')
    );
    $schedules['monthly']       = array(
        'interval' => 2592000,
        'display' => esc_html__('Once Monthly', 'multilive-multiple-live-stream-broadcaster')
    );
    return $schedules;
}
function mlsb_auto_clear_log()
{
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
       wp_filesystem($creds);
    }
    if ($wp_filesystem->exists(WP_CONTENT_DIR . '/mlsb_info.log')) {
        $wp_filesystem->delete(WP_CONTENT_DIR . '/mlsb_info.log');
    }
}

register_deactivation_hook(__FILE__, 'mlsb_my_deactivation');
function mlsb_my_deactivation()
{
    wp_clear_scheduled_hook('mlsbactionclear');
}
add_action('mlsbactionclear', 'mlsb_auto_clear_log');

function mlsb_cron_schedule()
{
    $mlsb_Main_Settings = get_option('mlsb_Main_Settings', false);
    if (isset($mlsb_Main_Settings['mlsb_enabled']) && $mlsb_Main_Settings['mlsb_enabled'] === 'on') {
        if (isset($mlsb_Main_Settings['enable_logging']) && $mlsb_Main_Settings['enable_logging'] === 'on' && isset($mlsb_Main_Settings['auto_clear_logs']) && $mlsb_Main_Settings['auto_clear_logs'] !== 'No') {
            if (!wp_next_scheduled('mlsbactionclear')) {
                $rez = wp_schedule_event(time(), $mlsb_Main_Settings['auto_clear_logs'], 'mlsbactionclear');
                if ($rez === FALSE) {
                    mlsb_log_to_file('[Scheduler] Failed to schedule mlsbactionclear to ' . $mlsb_Main_Settings['auto_clear_logs'] . '!');
                }
                add_option('mlsb_schedule_time', $mlsb_Main_Settings['auto_clear_logs']);
            } else {
                if (!get_option('mlsb_schedule_time')) {
                    wp_clear_scheduled_hook('mlsbactionclear');
                    $rez = wp_schedule_event(time(), $mlsb_Main_Settings['auto_clear_logs'], 'mlsbactionclear');
                    add_option('mlsb_schedule_time', $mlsb_Main_Settings['auto_clear_logs']);
                    if ($rez === FALSE) {
                        mlsb_log_to_file('[Scheduler] Failed to schedule mlsbactionclear to ' . $mlsb_Main_Settings['auto_clear_logs'] . '!');
                    }
                } else {
                    $the_time = get_option('mlsb_schedule_time');
                    if ($the_time != $mlsb_Main_Settings['auto_clear_logs']) {
                        wp_clear_scheduled_hook('mlsbactionclear');
                        delete_option('mlsb_schedule_time');
                        $rez = wp_schedule_event(time(), $mlsb_Main_Settings['auto_clear_logs'], 'mlsbactionclear');
                        add_option('mlsb_schedule_time', $mlsb_Main_Settings['auto_clear_logs']);
                        if ($rez === FALSE) {
                            mlsb_log_to_file('[Scheduler] Failed to schedule mlsbactionclear to ' . $mlsb_Main_Settings['auto_clear_logs'] . '!');
                        }
                    }
                }
            }
        } else {
            if (!wp_next_scheduled('mlsbactionclear')) {
                delete_option('mlsb_schedule_time');
            } else {
                wp_clear_scheduled_hook('mlsbactionclear');
                delete_option('mlsb_schedule_time');
            }
        }
    } else {
        if (!wp_next_scheduled('mlsbactionclear')) {
            delete_option('mlsb_schedule_time');
        } else {
            wp_clear_scheduled_hook('mlsbactionclear');
            delete_option('mlsb_schedule_time');
        }
    }
}

function mlsb_log_to_file($str)
{
    $mlsb_Main_Settings = get_option('mlsb_Main_Settings', false);
    if (isset($mlsb_Main_Settings['enable_logging']) && $mlsb_Main_Settings['enable_logging'] == 'on') {
        $d = date("j-M-Y H:i:s e", current_time( 'timestamp' ));
        error_log("[$d] " . $str . "<br/>\r\n", 3, WP_CONTENT_DIR . '/mlsb_info.log');
    }
}

function mlsb_isCurl(){
    return function_exists('curl_version');
}

function mlsb_get_random_user_agent() {
	$agents = array(
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/603.3.8 (KHTML, like Gecko) Version/10.1.2 Safari/603.3.8",
		"Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; WOW64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko",
		"Mozilla/5.0 (Windows NT 6.1; WOW64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/52.0.2743.116 Safari/537.36 Edge/15.15063",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:55.0) Gecko/20100101 Firefox/55.0",
		"Mozilla/5.0 (Windows NT 10.0; WOW64; rv:54.0) Gecko/20100101 Firefox/54.0",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
		"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.101 Safari/537.36"
	);
	$rand   = rand( 0, count( $agents ) - 1 );
	return trim( $agents[ $rand ] );
}
function mlsb_get_web_page($url)
{
    $content = false;
    $mlsb_Main_Settings = get_option('mlsb_Main_Settings', false);
    if (!isset($mlsb_Main_Settings['proxy_url']) || $mlsb_Main_Settings['proxy_url'] == '') {
        $args = array(
           'timeout'     => 10,
           'redirection' => 10,
           'user-agent'  => mlsb_get_random_user_agent(),
           'blocking'    => true,
           'headers'     => array(),
           'cookies'     => array(),
           'body'        => null,
           'compress'    => false,
           'decompress'  => true,
           'sslverify'   => false,
           'stream'      => false,
           'filename'    => null
        );
        $ret_data            = wp_remote_get(html_entity_decode($url), $args);  
        $response_code       = wp_remote_retrieve_response_code( $ret_data );
        $response_message    = wp_remote_retrieve_response_message( $ret_data );        
        if ( 200 != $response_code ) {
        } else {
            $content = wp_remote_retrieve_body( $ret_data );
        }
    }
    if($content === false)
    {
        if(mlsb_isCurl() && filter_var($url, FILTER_VALIDATE_URL))
        {
            $user_agent = mlsb_get_random_user_agent();
            $options    = array(
                CURLOPT_CUSTOMREQUEST => "GET",
                CURLOPT_POST => false,
                CURLOPT_USERAGENT => $user_agent,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_HEADER => false,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_ENCODING => "",
                CURLOPT_AUTOREFERER => true,
                CURLOPT_CONNECTTIMEOUT => 10,
                CURLOPT_TIMEOUT => 10,
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_REFERER => get_site_url(),
                CURLOPT_SSL_VERIFYHOST => 0,
                CURLOPT_SSL_VERIFYPEER => 0
            );
            $ch         = curl_init($url);
            if ($ch !== FALSE) {
                if (isset($mlsb_Main_Settings['proxy_url']) && $mlsb_Main_Settings['proxy_url'] != '') {
                    curl_setopt($ch, CURLOPT_PROXY, $mlsb_Main_Settings['proxy_url']);
                    if (isset($mlsb_Main_Settings['proxy_auth']) && $mlsb_Main_Settings['proxy_auth'] != '') {
                        curl_setopt($ch, CURLOPT_PROXYUSERPWD, $mlsb_Main_Settings['proxy_auth']);
                    }
                }
                curl_setopt_array($ch, $options);
                $content = curl_exec($ch);
                curl_close($ch);
            }
        }
        if($content === false)
        {
            $allowUrlFopen = preg_match('/1|yes|on|true/i', ini_get('allow_url_fopen'));
            if ($allowUrlFopen) {
                global $wp_filesystem;
                if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
                    include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
                    wp_filesystem($creds);
                }
                return $wp_filesystem->get_contents($url);
            }
        }
    }
    return $content;
}

function mlsb_isSecure() {
  return
    (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off')
    || $_SERVER['SERVER_PORT'] == 443;
}
add_action('wp_ajax_mlsb_post_now', 'mlsb_mlsb_submit_post_callback');
function mlsb_mlsb_submit_post_callback()
{
    $run_id = $_POST['id'];
    $wp_post = get_post($run_id);
    if($wp_post != null)
    {
        mlsb_do_post($wp_post, true);
    }
    die();
}

add_action('init', 'mlsb_create_taxonomy', 0);
function mlsb_general_admin_notice(){
    echo '<div class="notice notice-warning">
        <p>' . esc_html__('This is a demo version of the "MultiLive - Live Streaming Broadcaster" plugin. You can stream only 1 live video every 30 minutes. Also, the maximum length for streamed videos is 3 minutes.', 'multilive-multiple-live-stream-broadcaster') . '</p>
    </div>';
}

function mlsb_create_taxonomy()
{
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    $is_demo = get_option('mlsb_demo', false);
    if($is_demo === '1')
    {
        add_action('admin_notices', 'mlsb_general_admin_notice');
    }
    $secret_key = get_option('mlsb_uniqid', false);
    if (isset($_GET['mlsb_cronjob']) && $_GET['mlsb_cronjob'] == '1' && isset($_GET['mlsb_key']) && $_GET['mlsb_key'] === $secret_key)
    {
        $mlsb_Main_Settings = get_option('mlsb_Main_Settings', false);
        $mlsb_Youtube_Settings = get_option('mlsb_Youtube_Settings', false);
        $conti = false;
        if (isset($mlsb_Youtube_Settings['enable_conti']) && $mlsb_Youtube_Settings['enable_conti'] == 'on') {
            $conti = true;
            $f = fopen(get_temp_dir() . 'multilive', 'w');
            if($f !== false)
            {
                $flock_disabled = explode(',', ini_get('disable_functions'));
                if(!in_array('flock', $flock_disabled))
                {
                    if (!flock($f, LOCK_EX | LOCK_NB)) {
                        if(isset($mlsb_Main_Settings['enable_detailed_logging']) && $mlsb_Main_Settings['enable_detailed_logging'] == 'on')
                        {
                            mlsb_log_to_file('Live streaming already running.');
                        }
                        exit();
                    }
                }
            }
        }
        $GLOBALS['wp_object_cache']->delete('mlsb_execstr', 'options');
        $GLOBALS['wp_object_cache']->delete('mlsb_filename', 'options');
        $mlsb_execstr = get_option('mlsb_execstr', false);
        $mlsb_filename = get_option('mlsb_filename', false);
        if($mlsb_execstr !== false && $mlsb_filename !== false)
        {
            if (isset($mlsb_Main_Settings['rule_timeout']) && $mlsb_Main_Settings['rule_timeout'] != '') {
                $timeout = intval($mlsb_Main_Settings['rule_timeout']);
            } else {
                $timeout = 3600;
            }
            ini_set('safe_mode', 'Off');
            ini_set('max_execution_time', $timeout);
            ini_set('ignore_user_abort', 1);
            if(function_exists('ignore_user_abort'))
{
    ignore_user_abort(true);
}
            if(function_exists('set_time_limit'))
{
    set_time_limit($timeout);
}
            if($conti == true && is_array($mlsb_execstr) && is_array($mlsb_filename))
            {
                while(count($mlsb_execstr) > 0 && count($mlsb_filename) > 0)
                {
                    $curr_exec = array_shift($mlsb_execstr);
                    update_option('mlsb_execstr', $mlsb_execstr, false);
                    $curr_filename = array_shift($mlsb_filename);
                    update_option('mlsb_filename', $mlsb_filename, false);
                    if (isset($mlsb_Youtube_Settings['loop_video']) && $mlsb_Youtube_Settings['loop_video'] != '') {
                        $loop_c = intval($mlsb_Youtube_Settings['loop_video']);
                    }
                    else
                    {
                        $loop_c = 1;
                    }
                    for($i = 1; $i <= $loop_c; $i++)
                    {
                        if(isset($mlsb_Main_Settings['enable_detailed_logging']) && $mlsb_Main_Settings['enable_detailed_logging'] == 'on')
                        {
                            mlsb_log_to_file('Sending command to ffmpeg (' . $i . '): ' . $curr_exec);
                        }
                        $shefunc = trim(' s ') . trim(' h ') . 'ell' . '_exec';
                        $rez = $shefunc($curr_exec);
                        if(isset($mlsb_Main_Settings['enable_detailed_logging']) && $mlsb_Main_Settings['enable_detailed_logging'] == 'on')
                        {
                            mlsb_log_to_file('Streaming finished (' . $i . '): ' . $rez);
                        }
                    }
                    if ($wp_filesystem->exists($curr_filename)) {
                        $wp_filesystem->delete($curr_filename);
                    }
                    $GLOBALS['wp_object_cache']->delete('mlsb_execstr', 'options');
                    $GLOBALS['wp_object_cache']->delete('mlsb_filename', 'options');
                    $mlsb_execstr = get_option('mlsb_execstr', false);
                    $mlsb_filename = get_option('mlsb_filename', false);
                }
            }
            else
            {
                if (isset($mlsb_Youtube_Settings['loop_video']) && $mlsb_Youtube_Settings['loop_video'] != '') {
                    $loop_c = intval($mlsb_Youtube_Settings['loop_video']);
                }
                else
                {
                    $loop_c = 1;
                }
                for($i = 1; $i <= $loop_c; $i++)
                {
                    if(isset($mlsb_Main_Settings['enable_detailed_logging']) && $mlsb_Main_Settings['enable_detailed_logging'] == 'on')
                    {
                        mlsb_log_to_file('Sending command to ffmpeg (' . $i . '): ' . $mlsb_execstr);
                    }
                    $shefunc = trim(' s ') . trim(' h ') . 'ell' . '_exec';
                    $rez = $shefunc($mlsb_execstr);
                    if(isset($mlsb_Main_Settings['enable_detailed_logging']) && $mlsb_Main_Settings['enable_detailed_logging'] == 'on')
                    {
                        mlsb_log_to_file('Streaming finished (' . $i . '): ' . $rez);
                    }
                }
                update_option('mlsb_execstr', false, false);
                update_option('mlsb_filename', false, false);
                if ($wp_filesystem->exists($mlsb_filename)) {
                    $wp_filesystem->delete($mlsb_filename);
                }
            }
            exit();
        }
    }
}

add_action( 'amin_init', 'mlsb_stop_heartbeat', 1 );
function mlsb_stop_heartbeat() {
    $mlsb_Main_Settings = get_option('mlsb_Main_Settings', false);
    if (!isset($mlsb_Main_Settings['leave_heart']) || $mlsb_Main_Settings['leave_heart'] != 'on')
    {
        wp_deregister_script('heartbeat');
    }
}

register_activation_hook(__FILE__, 'mlsb_activation_callback');
function mlsb_activation_callback($defaults = FALSE)
{
    if (!get_option('mlsb_Main_Settings') || $defaults === TRUE) {
        $mlsb_Main_Settings = array(
            'mlsb_enabled' => 'on',
            'mlsb_notice_enabled' => 'on',
            'ffmpeg_path' => '',
            'max_size' => '',
            'skip_no_img' => '',
            'skip_old' => '',
            'skip_year' => '',
            'skip_month' => '',
            'skip_day' => '',
            'translate' => 'disabled',
            'translate_source' => 'disabled',
            'litte_translate' => '',
            'custom_html2' => '',
            'custom_html' => '',
            'strip_by_id' => '',
            'link_back' => '',
            'link_soft' => '',
            'strip_by_class' => '',
            'auto_clear_logs' => 'No',
            'enable_logging' => 'on',
            'enable_detailed_logging' => '',
            'rule_timeout' => '3600',
            'leave_heart' => '',
            'resize_height' => '',
            'resize_width' => '',
            'copy_images' => '',
			'no_local_image' => '',
            'wide_images' => '43',
            'continue_search' => 'on',
            'fix_html' => '',
            'image_ad' => '',
			'proxy_auth' => '',
			'proxy_url' => ''
        );
        if ($defaults === FALSE) {
            add_option('mlsb_Main_Settings', $mlsb_Main_Settings);
        } else {
            update_option('mlsb_Main_Settings', $mlsb_Main_Settings);
        }
    }
    if (!get_option('mlsb_Youtube_Settings') || $defaults === TRUE) {
        $mlsb_Youtube_Settings = array(
            'mlsb_posting' => 'on',
            'run_background' => 'on',
            'enable_conti' => 'on',
            'loop_video' => '',
            'post_posts' => '',
            'post_pages' => 'on',
            'post_custom' => 'on',
            'except_type' => '',
            'disabled_categories' => array(),
            'disable_tags' => '',
            'only_local' => '',
            'only_remote' => '',
            'max_at_once' => '1',
            'server_url' => '',
            'max_bit_rate' => '',
            'min_bit_rate' => '',
            'server_key' => '',
            'multi_stream' => '',
            'custom_params' => '',
            'video_width' => 'default',
            'video_height' => 'default',
            'frame_rate' => '30',
            'youtube_embedded' => 'on',
            'tiktok_embedded' => 'on',
            'vimeo_embedded' => 'on',
            'dm_embedded' => 'on',
            'fb_embedded' => 'on',
            'tw_embedded' => 'on',
            'delay_post' => ''
        );
        if ($defaults === FALSE) {
            add_option('mlsb_Youtube_Settings', $mlsb_Youtube_Settings);
        } else {
            update_option('mlsb_Youtube_Settings', $mlsb_Youtube_Settings);
        }
    }
}

function mlsb_get_mime ($filename) {
    $mime_types = array(
        'txt' => 'text/plain',
        'htm' => 'text/html',
        'html' => 'text/html',
        'php' => 'text/html',
        'css' => 'text/css',
        'js' => 'application/javascript',
        'json' => 'application/json',
        'xml' => 'application/xml',
        'swf' => 'application/x-shockwave-flash',
        'flv' => 'video/x-flv',
        'png' => 'image/png',
        'jpe' => 'image/jpeg',
        'jpeg' => 'image/jpeg',
        'jpg' => 'image/jpeg',
        'gif' => 'image/gif',
        'bmp' => 'image/bmp',
        'ico' => 'image/vnd.microsoft.icon',
        'tiff' => 'image/tiff',
        'mts' => 'video/mp2t',
        'tif' => 'image/tiff',
        'svg' => 'image/svg+xml',
        'svgz' => 'image/svg+xml',
        'zip' => 'application/zip',
        'rar' => 'application/x-rar-compressed',
        'exe' => 'application/x-msdownload',
        'msi' => 'application/x-msdownload',
        'cab' => 'application/vnd.ms-cab-compressed',
        'mp3' => 'audio/mpeg',
        'qt' => 'video/quicktime',
        'mov' => 'video/quicktime',
        'wmv' => 'video/x-ms-wmv',
        'mp4' => 'video/mp4',
        'm4p' => 'video/m4p',
        'm4v' => 'video/m4v',
        'mpg' => 'video/mpg',
        'mp2' => 'video/mp2',
        'mpe' => 'video/mpe',
        'mpv' => 'video/mpv',
        'm2v' => 'video/m2v',
        'm4v' => 'video/m4v',
        '3g2' => 'video/3g2',
        '3gpp' => 'video/3gpp',
        'f4v' => 'video/f4v',
        'f4p' => 'video/f4p',
        'f4a' => 'video/f4a',
        'f4b' => 'video/f4b',
        '3gp' => 'video/3gp',
        'avi' => 'video/x-msvideo',
        'mpeg' => 'video/mpeg',
        'mpegps' => 'video/mpeg',
        'webm' => 'video/webm',
        'mpeg4' => 'video/mp4',
        'mkv' => 'video/mkv',
        'pdf' => 'application/pdf',
        'psd' => 'image/vnd.adobe.photoshop',
        'ai' => 'application/postscript',
        'eps' => 'application/postscript',
        'ps' => 'application/postscript',
        'doc' => 'application/msword',
        'rtf' => 'application/rtf',
        'xls' => 'application/vnd.ms-excel',
        'ppt' => 'application/vnd.ms-powerpoint',
        'docx' => 'application/msword',
        'xlsx' => 'application/vnd.ms-excel',
        'pptx' => 'application/vnd.ms-powerpoint',
        'odt' => 'application/vnd.oasis.opendocument.text',
        'ods' => 'application/vnd.oasis.opendocument.spreadsheet',
    );
    $ext = array_values(array_slice(explode('.', $filename), -1));$ext = $ext[0];

    if(stristr($filename, 'dailymotion.com'))
    {
        return 'application/octet-stream';
    }
    if (function_exists('mime_content_type')) {
        error_reporting(0);
        $mimetype = mime_content_type($filename);
        error_reporting(E_ALL);
        if($mimetype == '')
        {
            if (array_key_exists($ext, $mime_types)) {
                return $mime_types[$ext];
            } else {
                return 'application/octet-stream';
            }
        }
        return $mimetype;
    }
    elseif (function_exists('finfo_open')) {
        $finfo = finfo_open(FILEINFO_MIME);
        $mimetype = finfo_file($finfo, $filename);
        finfo_close($finfo);
        if($mimetype === false)
        {
            if (array_key_exists($ext, $mime_types)) {
                return $mime_types[$ext];
            } else {
                return 'application/octet-stream';
            }
        }
        return $mimetype;

    } elseif (array_key_exists($ext, $mime_types)) {
        return $mime_types[$ext];
    } else {
        return 'application/octet-stream';
    }
}
function mlsb_IsResourceRemoteVideo($url)
{
    if( empty( $url ) )
    {
        return false; 
    }
    $extension_found = false;
    $videoExtensions = array("webm", "mpg", "mpeg", "mpe", "mp4", "m4p", "m4v", "avi", "wmv", "mov");
    foreach($videoExtensions as $vid_ext)
    {
        if(stristr($url, '.' . $vid_ext) !== false)
        {
            $extension_found = true;
            break;
        }
    }
    if($extension_found == false)
    {
        return false;
    }
    $urlParsed = parse_url( $url );
    $host = $urlParsed['host'];
    if( empty( $host ) )
    { 
        return false;
    }
    $host = str_replace('www.', '', $host);
    $thishost = $_SERVER['HTTP_HOST'];
    $thishost = str_replace('www.', '', $thishost);
    if( $host != $thishost ){
        return true;
    }
    return false;
}
function mlsb_IsResourceLocal($url){
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    if( empty( $url ) ){ return false; }
    $urlParsed = parse_url( $url );
    $host = $urlParsed['host'];
    if( empty( $host ) ){ 
        $doc_root = $_SERVER['DOCUMENT_ROOT'];
        $maybefile = $doc_root.$url;
        $fileexists = $wp_filesystem->exists ( $maybefile );
        if( $fileexists ){
            return true;        
        }
    }
    $host = str_replace('www.','',$host);
    $thishost = $_SERVER['HTTP_HOST'];
    $thishost = str_replace('www.','',$thishost);
    if( $host == $thishost ){
        return true;
    }
    return false;
}

function mlsb_filter_autosave_interval($interval){
	return 60 * 60 * 60;
}
function mlsb_getUrls($string) {
        $regex = '/https?\:\/\/[^\"\' \n\s]+/i';
        preg_match_all($regex, $string, $matches);
        return ($matches[0]);
}
function mlsb_upload_media_library($image_url)
{
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    $upload_dir = wp_upload_dir();
    $myid = uniqid();
    if (wp_mkdir_p($upload_dir['path']))
    {
        $file = $upload_dir['path'] . '/youtubetempupload' . $myid . '.mp4';
        $path = $upload_dir['url'] . '/youtubetempupload' . $myid . '.mp4';
    }
    else
    {
        $file = $upload_dir['basedir'] . '/youtubetempupload' . $myid . '.mp4';
        $path = $upload_dir['baseurl'] . '/youtubetempupload' . $myid . '.mp4';
    }
    $ret = $wp_filesystem->copy($image_url, $file, true);
    if($ret === false)
    {
        if(!$wp_filesystem->exists($file))
        {
            $errors= error_get_last();
            mlsb_log_to_file('Failed to copy video file ' . $image_url . ' locally to server to ' . $file . ': ' . $errors['type'] . ' - ' . $errors['message']);
            return false;
        }
        else
        {
            return array($path, $file);
        }
    }
    else
    {
        return array($path, $file);
    }
}
function mlsb_getDMMP4($vimeo_id) 
{
    $result = dmomatic_get_web_page("https://www.dailymotion.com/player/metadata/video/" . $vimeo_id);
    if($result === false)
    {
        global $wp_filesystem;
        if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
            include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
            wp_filesystem($creds);
        }
        $result = $wp_filesystem->get_contents($vimeo_id);
    }
    if($result === false)
    {
        return false;
    }
    $data = json_decode($result, true);
    if($data === false || !isset($data['qualities']['auto'][0]['url']))
    {
        return false;
    }
    $xresult = dmomatic_get_web_page($data['qualities']['auto'][0]['url']);
    if($xresult === false)
    {
        return false;
    }
    preg_match_all('/#EXT-X-STREAM-INF:(.*)/', $xresult, $streamsRaw);
    if(!isset($streamsRaw[1]))
    {
        return false;
    }
    $xresult = $streamsRaw[1];
    $streams = array();
    foreach ($xresult as $stream) 
    {
        $quality = dmomatic_getStringBetween($stream, 'NAME="', '"');
        $streams[$quality]['url'] = dmomatic_getStringBetween($stream, 'PROGRESSIVE-URI="', '"');
    }
    $retur = '';
    ksort($streams, SORT_NUMERIC);
    if(count($streams) > 0)
    {
        $retur = end($streams);
        $retur = $retur['url'];
    }
    return $retur;
}
function mlsb_getFBMP4($vimeo_id) 
{
    $result = mlsb_get_web_page($vimeo_id);
    if($result === false)
    {
        global $wp_filesystem;
        if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
            include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
            wp_filesystem($creds);
        }
        $result = $wp_filesystem->get_contents($vimeo_id);
    }
    if($result === false)
    {
        return false;
    }                               
    preg_match_all('#hd_src(?:_no_ratelimit)?:"([^"]+?)"#i', $result, $matches);
    if(!isset($matches[1][0]))
    {
        return false;
    }
    return $matches[1][0];
}
function mlsb_getTWMP4($vimeo_id) 
{
    $result = mlsb_get_web_page($vimeo_id);
    if($result === false)
    {
        global $wp_filesystem;
        if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
            include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
            wp_filesystem($creds);
        }
        $result = $wp_filesystem->get_contents($vimeo_id);
    }
    if($result === false)
    {
        return false;
    }
    preg_match_all('#{"quality":"720","source":"(.+?)"#i', $result, $matches);
    if(!isset($matches[1][0]))
    {
        return false;
    }
    return $matches[1][0];
}

function mlsb_getVimeoMP4($vimeo_id) 
{
    require_once(dirname(__FILE__) . "/res/vimeodl.php");
    $vd = new VideoControllerDownloaderLoader();
    $vimeo_link = $vd->getVimeoDirectUrl('https://vimeo.com/' . $vimeo_id);
    return trim($vimeo_link);
}

add_action('mlsb_new_post_cron', 'mlsb_do_post', 10, 1);
add_action('transition_post_status', 'mlsb_new_post', 10, 3);

function mlsb_new_post($new_status, $old_status, $post)
{
    if ('publish' !== $new_status or 'publish' === $old_status)
    {
        return;
    }
    else
    {
        if($old_status == 'auto-draft' && $new_status == 'publish' && !has_post_thumbnail($post->ID) && ((function_exists('has_blocks') && has_blocks($post)) || ($post->post_content == '' && function_exists('has_blocks') && !class_exists('Classic_Editor'))))
        {
            $delay_it_is_gutenberg = true;
        }
        else
        {
            $delay_it_is_gutenberg = false;
        }
    }
    $mlsb_Main_Settings = get_option('mlsb_Main_Settings', false);
    if (isset($mlsb_Main_Settings['mlsb_enabled']) && $mlsb_Main_Settings['mlsb_enabled'] == 'on') 
    {
        $mlsb_Youtube_Settings = get_option('mlsb_Youtube_Settings', false);
        if (isset($mlsb_Youtube_Settings['mlsb_posting']) && $mlsb_Youtube_Settings['mlsb_posting'] == 'on') {
            if (isset($mlsb_Youtube_Settings['delay_post']) && $mlsb_Youtube_Settings['delay_post'] != '' && is_numeric($mlsb_Youtube_Settings['delay_post'])) {
                if(wp_next_scheduled('mlsb_new_post_cron', array($post)) === false)
                {
                    if($delay_it_is_gutenberg && $mlsb_Youtube_Settings['delay_post'] < 2)
                    {
                        $mlsb_Youtube_Settings['delay_post'] = 2;
                    }
                    wp_schedule_single_event( time() + intval($mlsb_Youtube_Settings['delay_post']), 'mlsb_new_post_cron', array($post) );
                }
            }
            else
            {
                if (isset($mlsb_Youtube_Settings['run_background']) && $mlsb_Youtube_Settings['run_background'] == 'on') {
                    if($delay_it_is_gutenberg)
                    {
                        if(wp_next_scheduled('mlsb_new_post_cron', array($post)) === false)
                        {
                            wp_schedule_single_event( time() + 2, 'mlsb_new_post_cron', array($post) );
                        }
                    }
                    else
                    {
                        $unique_id = uniqid();
                        update_option('mlsb_do_post_uniqid', $unique_id);
                        $xcron_url = site_url( '?mlsb_do_post_cronjob=1&post_id=' . $post->ID . '&mlsb_do_post_key=' . $unique_id);
                        wp_remote_post( $xcron_url, array( 'timeout' => 1, 'blocking' => false, 'sslverify' => false ) );
                    }
                }
                else
                {
                    if($delay_it_is_gutenberg)
                    {
                        if(wp_next_scheduled('mlsb_new_post_cron', array($post)) === false)
                        {
                            wp_schedule_single_event( time() + 2, 'mlsb_new_post_cron', array($post) );
                        }
                    }
                    else
                    {
                        mlsb_do_post($post);
                    }
                }
            }
        }
    }
}
add_action('init', 'mlsb_do_post_callback', 0);
function mlsb_do_post_callback()
{
    $secretp_key = get_option('mlsb_do_post_uniqid', false);
    if (isset($_GET['mlsb_do_post_cronjob']) && $_GET['mlsb_do_post_cronjob'] == '1' && isset($_GET['post_id']) && is_numeric($_GET['post_id']) && $_GET['mlsb_do_post_key'] === $secretp_key)
    {
        $post = get_post($_GET['post_id']);
        if($post !== null)
        {
            mlsb_do_post($post);
            exit();
        }
    }
}
function mlsb_tk_getContent($url)
{
    $ch = curl_init();
    if($ch === false)
    {
        return false;
    }
    $options = array(
        CURLOPT_URL            => $url,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_HEADER         => false,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_USERAGENT      => mlsb_get_random_user_agent(),
        CURLOPT_ENCODING       => "utf-8",
        CURLOPT_AUTOREFERER    => false,
        CURLOPT_COOKIEJAR      => get_temp_dir() . 'cookie.txt',
	    CURLOPT_COOKIEFILE     => get_temp_dir() . 'cookie.txt',
        CURLOPT_REFERER        => 'https://www.tiktok.com/',
        CURLOPT_CONNECTTIMEOUT => 30,
        CURLOPT_SSL_VERIFYHOST => false,
        CURLOPT_SSL_VERIFYPEER => false,
        CURLOPT_TIMEOUT        => 30,
        CURLOPT_MAXREDIRS      => 10,
    );
    curl_setopt_array( $ch, $options );
    if (defined('CURLOPT_IPRESOLVE') && defined('CURL_IPRESOLVE_V4')) {
      curl_setopt($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4);
    }
    $data = curl_exec($ch);
    if($data === false)
    {
        return false;
    }
    curl_close($ch);
    return strval($data);
}
function mlsb_tk_downloadVideo($video_url)
{
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    $upload_dir = wp_upload_dir();
    $rand = uniqid();
    if (wp_mkdir_p($upload_dir['path']))
    {
        $file = $upload_dir['path'] . '/youtubetempupload' . $rand . '.mp4';
        $path = $upload_dir['url'] . '/youtubetempupload' . $rand . '.mp4';
    }
    else
    {
        $file = $upload_dir['basedir'] . '/youtubetempupload' . $rand . '.mp4';
        $path = $upload_dir['baseurl'] . '/youtubetempupload' . $rand . '.mp4';
    }
    
    $ch = curl_init();
    if($ch === false)
    {
        return false;
    }
    $headers = array(
        'Range: bytes=0-',
    );
    $options = array(
        CURLOPT_URL            => $video_url,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_HEADER         => false,
        CURLOPT_HTTPHEADER     => $headers,
        CURLOPT_FOLLOWLOCATION => true,
        CURLINFO_HEADER_OUT    => true,
        CURLOPT_USERAGENT      => 'okhttp',
        CURLOPT_ENCODING       => "utf-8",
        CURLOPT_AUTOREFERER    => true,
        CURLOPT_COOKIEJAR      => get_temp_dir() . 'cookie.txt',
	    CURLOPT_COOKIEFILE     => get_temp_dir() . 'cookie.txt',
        CURLOPT_REFERER        => 'https://www.tiktok.com/',
        CURLOPT_CONNECTTIMEOUT => 30,
        CURLOPT_SSL_VERIFYHOST => false,
        CURLOPT_SSL_VERIFYPEER => false,
        CURLOPT_TIMEOUT        => 30,
        CURLOPT_MAXREDIRS      => 10,
    );
    curl_setopt_array( $ch, $options );
    if (defined('CURLOPT_IPRESOLVE') && defined('CURL_IPRESOLVE_V4')) 
    {
        curl_setopt($ch, CURLOPT_IPRESOLVE, CURL_IPRESOLVE_V4);
    }
    $data = curl_exec($ch);
    if($data === false)
    {
        return false;
    }
    curl_close($ch);
    $d = fopen($file, "w");
    if($d === false)
    {
        return false;
    }
    $e = fwrite($d, $data);
    if($e === false)
    {
        return false;
    }
    fclose($d);
    return array($path, $file);
}
function mlsb_do_post($post, $manual = false)
{
    global $wp_filesystem;
    if ( ! is_a( $wp_filesystem, 'WP_Filesystem_Base') ){
        include_once(ABSPATH . 'wp-admin/includes/file.php');$creds = request_filesystem_credentials( site_url() );
        wp_filesystem($creds);
    }
    $is_demo = get_option('mlsb_demo', false);
    if($is_demo === '1')
    {
        $last_time = get_option('mlsb_demo_last_time', false);
        if($last_time !== false)
        {
            if(time() <= $last_time + 1800)
            {
                mlsb_log_to_file('Please slow posting down. This is just a demo.');
                return;
            }
        }
    }
       
    $mlsb_Main_Settings = get_option('mlsb_Main_Settings', false);
    if (isset($mlsb_Main_Settings['rule_timeout']) && $mlsb_Main_Settings['rule_timeout'] != '') {
        $timeout = intval($mlsb_Main_Settings['rule_timeout']);
    } else {
        $timeout = 3600;
    }
    ini_set('safe_mode', 'Off');
    ini_set('max_execution_time', $timeout);
    ini_set('ignore_user_abort', 1);
    if(function_exists('ignore_user_abort'))
{
    ignore_user_abort(true);
}
    if(function_exists('set_time_limit'))
{
    set_time_limit($timeout);
}
    if (isset($mlsb_Main_Settings['mlsb_enabled']) && $mlsb_Main_Settings['mlsb_enabled'] == 'on') {
        $mlsb_Youtube_Settings = get_option('mlsb_Youtube_Settings', false);
        if ($manual || isset($mlsb_Youtube_Settings['mlsb_posting']) && $mlsb_Youtube_Settings['mlsb_posting'] == 'on') {
            if (!$manual && isset($mlsb_Youtube_Settings['post_posts'])) {
                if ($mlsb_Youtube_Settings['post_posts'] == 'on' && 'post' === $post->post_type) {
                    return;
                }
            }
            if (!$manual && isset($mlsb_Youtube_Settings['post_pages'])) {
                if ($mlsb_Youtube_Settings['post_pages'] == 'on' && 'page' === $post->post_type) {
                    return;
                }
            }
            if (!$manual && isset($mlsb_Youtube_Settings['post_custom'])) {
                if ($mlsb_Youtube_Settings['post_custom'] == 'on' && 'page' != $post->post_type && 'post' != $post->post_type) {
                    if (isset($mlsb_Youtube_Settings['except_type']) && $mlsb_Youtube_Settings['except_type'] != '') 
                    {
                        $excepted_types = explode(',', $mlsb_Youtube_Settings['except_type']);
                        $excepted_types = array_map('trim', $excepted_types);
                        if(!in_array($post->post_type, $excepted_types))
                        {
                            return;
                        }
                    }
                    else
                    {
                        return;
                    }
                }
            }
            $ffmpeg_res = get_option('mlsb_ffmpeg_res', false);
            if($ffmpeg_res !== '1')
            {
                return;
            }
            $deletes = array();
            $post_cats        = get_post_meta($post->ID, 'mlsb_post_cats', true);
            if($post_cats == '')
            {
                $cats = wp_get_post_categories($post->ID);
                $post_categories = array();
                foreach($cats as $c){
                    $cat = get_category( $c );
                    $post_categories[] = $cat->name;
                }
                $post_cats = implode(',', $post_categories);
            }
            else
            {
                $post_categories  = explode(',', $post_cats);
            }
            if(count($post_categories) == 0)
            {
                $terms = get_the_terms( $post->ID, 'product_cat' );
                if ( ! empty( $terms ) && ! is_wp_error( $terms ) ){
                    foreach ( $terms as $term ) {
                        $post_categories[] = $term->slug;
                    }
                    $post_cats = implode(',', $post_categories);
                }
                
            }
            foreach($post_categories as $pc)
            {
                if (!$manual && isset($mlsb_Youtube_Settings['disabled_categories']) && !empty($mlsb_Youtube_Settings['disabled_categories'])) {
                    foreach($mlsb_Youtube_Settings['disabled_categories'] as $disabled_cat)
                    {
                        if(trim($pc) == get_cat_name($disabled_cat))
                        {
                            mlsb_log_to_file('Disabled category: ' . $pc);
                            return;
                        }
                    }
                }
            }
            $post_tagz = get_post_meta($post->ID, 'mlsb_post_tags', true);
            if($post_tagz == '')
            {
                $tags = wp_get_post_tags($post->ID);
                $post_tags = array();
                foreach($tags as $t){
                    $post_tags[] = $t->name;
                }
                $post_tagz = implode(',', $post_tags);
            }
            else
            {
                $post_tags = explode(',', $post_tagz);
            }
            if(count($post_tags) == 0)
            {
                $terms = get_the_terms( $post->ID, 'product_tag' );
                if ( ! empty( $terms ) && ! is_wp_error( $terms ) ){
                    foreach ( $terms as $term ) {
                        $post_tags[] = $term->slug;
                    }
                    $post_tagz = implode(',', $post_tags);
                }
                
            }
            foreach($post_tags as $pt)
            {
                if (!$manual && isset($mlsb_Youtube_Settings['disable_tags']) && $mlsb_Youtube_Settings['disable_tags'] != '') {
                    
                    $disable_tags = explode(",", $mlsb_Youtube_Settings['disable_tags']);
                    foreach($disable_tags as $disabled_tag)
                    {
                        if(trim($pt) == trim($disabled_tag))
                        {
                            mlsb_log_to_file('Disabled tag: ' . $pt);
                            return;
                        }
                    }
                }
            }
            if(!isset($mlsb_Youtube_Settings['server_url']) || $mlsb_Youtube_Settings['server_url'] == '' || !isset($mlsb_Youtube_Settings['server_key']) || $mlsb_Youtube_Settings['server_key'] == '')
            {
                return;
            }
            if (!isset($mlsb_Youtube_Settings['enable_conti']) || $mlsb_Youtube_Settings['enable_conti'] != 'on') {
                $f = fopen(get_temp_dir() . 'multilive', 'w');
                if($f !== false)
                {
                    if (!flock($f, LOCK_EX | LOCK_NB)) {
                        mlsb_log_to_file('Only one instance of profile live streaming is allowed. You will be able to stream more videos when the actual live stream finishes.');
                        return;
                    }
                }
            }
            $pm = get_post_meta($post->ID, "avc_modified", true);
            if($pm == 'y' || !$manual)
            {
                $mypost = get_post($post->ID);
                if($mypost !== null && isset($mypost->post_content))
                {
                    $post->post_content = $mypost->post_content;
                }
            }
            $finals = array();
            $att = mlsb_getUrls($post->post_content);
            $att = array_unique($att);
            if (isset($mlsb_Main_Settings['enable_detailed_logging']) && $mlsb_Main_Settings['enable_detailed_logging'] == 'on') 
            {
                mlsb_log_to_file('Found URLs in post: ' . print_r($att, true));
            }
            if(count($att) > 0)
            {
                foreach($att as $link)
                {
                    if(isset($mlsb_Youtube_Settings['only_local']) && $mlsb_Youtube_Settings['only_local'] == 'on')
                    {
                        if(mlsb_IsResourceLocal($link))
                        {
                            $mime = mlsb_get_mime($link);
                            if(stristr($mime, "video/mp2t") !== FALSE || stristr($mime, "video/quicktime") !== FALSE || stristr($mime, "video/mpeg4") !== FALSE || stristr($mime, "video/mp4") !== FALSE || stristr($mime, "video/x-msvideo") !== FALSE || stristr($mime, "video/x-ms-wmv") !== FALSE || stristr($mime, "video/mpeg") !== FALSE || stristr($mime, "video/x-flv") !== FALSE || stristr($mime, "video/3gpp") !== FALSE || stristr($mime, "video/webm") !== FALSE){
                                $finals[] = $link;
                            }
                        }
                    }
                    if(isset($mlsb_Youtube_Settings['only_remote']) && $mlsb_Youtube_Settings['only_remote'] == 'on')
                    {
                        if(!array_key_exists('remote' . $link, $finals) && mlsb_IsResourceRemoteVideo($link))
                        {
                            $local_path = mlsb_upload_media_library($link);
                            if($local_path !== false)
                            {
                                if (isset($mlsb_Main_Settings['enable_detailed_logging']) && $mlsb_Main_Settings['enable_detailed_logging'] == 'on') 
                                {
                                    mlsb_log_to_file('Found Remote Video Link: ' . print_r($local_path[0], true));
                                }
                                $finals['remote' . $link] = $local_path[0];
                                $deletes['remote' . $link] = $local_path[1];
                            }
                            else
                            {
                                if (isset($mlsb_Main_Settings['enable_detailed_logging']) && $mlsb_Main_Settings['enable_detailed_logging'] == 'on') 
                                {
                                    mlsb_log_to_file('Failed to upload remote video to local library: ' . print_r($link, true));
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                return;
            }
            foreach($att as $lnk)
            {
                {
                    if(isset($mlsb_Youtube_Settings['tiktok_embedded']) && $mlsb_Youtube_Settings['tiktok_embedded'] == 'on')
                    {
                        $id = '';
                        {
                            preg_match_all('#(?:https?:\/\/(?:www\.)?tiktok\.com\/@(?:[^/]+)\/video\/(\d+)\/?)#i', $lnk, $embeds);
                            if(isset($embeds[1][0]))
                            {
                                $id = $embeds[1][0];
                            }
                            else
                            {
                                preg_match_all('#(?:https?:\/\/(?:www\.)?vm\.tiktok\.com\/(\d+)\/?)#i', $lnk, $embeds);
                                if(isset($embeds[1][0]))
                                {
                                    $id = $embeds[1][0];
                                }
                            }
                        }
                        if (trim($id) != '') {
                            $url = 'https://www.tiktok.com/node/share/video/@' . $id . '/' . $id;
                            $resp = mlsb_tk_getContent($url);
                            if($resp !== false)
                            {
                                $check = explode('"downloadAddr":"', $resp);
                                if (count($check) > 1){
                                    $contentURL = explode("\"",$check[1])[0];
                                    $contentURL = str_replace("\\u0026", "&", $contentURL);
                                    if($contentURL != '')
                                    {
                                        $vid_dl = mlsb_tk_downloadVideo($contentURL);
                                        if($vid_dl !== false)
                                        {
                                            $finals[] = $vid_dl[0];
                                            $deletes[] = $vid_dl[1];
                                        }
                                        else
                                        {
                                            if (isset($mlsb_Main_Settings['enable_detailed_logging']) && $mlsb_Main_Settings['enable_detailed_logging'] == 'on') 
                                            {
                                                mlsb_log_to_file('Failed to upload TikTok video to local library: ' . print_r($contentURL, true));
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    if (isset($mlsb_Main_Settings['enable_detailed_logging']) && $mlsb_Main_Settings['enable_detailed_logging'] == 'on') 
                                    {
                                        mlsb_log_to_file('downloadAddr not found in TikTok response: ' . print_r($url, true));
                                    }
                                }
                            }
                        }
                    }
                    if(isset($mlsb_Youtube_Settings['youtube_embedded']) && $mlsb_Youtube_Settings['youtube_embedded'] == 'on')
                    {
                        $id = '';
                        parse_str( parse_url( $lnk, PHP_URL_QUERY ), $my_array_of_vars );
                        if(stristr($lnk, 'youtu') !== false && isset($my_array_of_vars['v']))
                        {
                            if(!preg_match('/^[A-Za-z0-9-_]+$/i', $my_array_of_vars['v']))
                            {
                                continue;
                            }
                            $id = $my_array_of_vars['v'];
                            
                        }
                        else
                        {
                            preg_match_all('#http(?:s)?:\/\/(?:www\.)?youtube\.com\/embed\/([^\/\s"\'?&]*)#i', $lnk, $embeds);
                            if(isset($embeds[1][0]))
                            {
                                $id = $embeds[1][0];
                            }
                            else
                            {
                                preg_match_all('#http(?:s)?:\/\/(?:www\.)?youtube\.com\/v\/([^\/\s"\'?&]*)#i', $lnk, $embeds);
                                if(isset($embeds[1][0]))
                                {
                                    $id = $embeds[1][0];
                                }
                                else
                                {
                                    preg_match_all('#http(?:s)?:\/\/(?:www\.)?youtu\.be\/([^\/\s"\'?&]*)#i', $lnk, $embeds);
                                    if(isset($embeds[1][0]))
                                    {
                                        $id = $embeds[1][0];
                                    }
                                    else
                                    {
                                        preg_match_all('#http(?:s)?:\/\/(?:www\.)?youtube\.com\/oembed\?url=http%3A\/\/(?:www\.)?youtube\.com\/watch\?v%3D([^\/\s"\'?&]*)#i', $lnk, $embeds);
                                        if(isset($embeds[1][0]))
                                        {
                                            $id = $embeds[1][0];
                                        }
                                        else
                                        {
                                            preg_match_all('#http(?:s)?:\/\/(?:www\.)?youtube\.com\/attribution_link\?a=(?:[^&])+&u=%2Fwatch%3Fv%3D([^\/\s"\'?&%]*)#i', $lnk, $embeds);
                                            if(isset($embeds[1][0]))
                                            {
                                                $id = $embeds[1][0];
                                            }
                                            else
                                            {
                                                preg_match_all('#http(?:s)?:\/\/(?:www\.)?youtube\.com\/watch\?v=([^\/\s"\'?&]*)#i', $lnk, $embeds);
                                                if(isset($embeds[1][0]))
                                                {
                                                    $id = $embeds[1][0];
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        if($id != '')
                        {
                            if(!class_exists('\YouTube\YouTubeDownloader'))
                            {
                                require_once(dirname(__FILE__) . "/res/youtube-dl/php-curl-client-master/src/Client.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/php-curl-client-master/src/BrowserClient.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/php-curl-client-master/src/CurlInfo.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/php-curl-client-master/src/Response.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/php-curl-file-downloader-master/src/ContentTypes.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/php-curl-file-downloader-master/src/HeaderHandler.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/php-curl-file-downloader-master/src/CurlDownloader.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Exception/YouTubeException.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Exception/TooManyRequestsException.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Exception/VideoNotFoundException.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Exception/VideoPlayerNotFoundException.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Models/AbstractModel.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Models/SplitStream.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Models/StreamFormat.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Models/VideoDetails.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Models/VideoInfo.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Models/InitialPlayerResponse.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Models/YouTubeConfigData.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Responses/HttpResponse.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Responses/PlayerApiResponse.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Responses/GetVideoInfo.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Responses/VideoPlayerJs.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Responses/WatchVideoPage.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Utils/ITagUtils.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Utils/SerializationUtils.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Utils/Utils.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Browser.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/DownloadOptions.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Parser.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/Utils.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/YoutubeStreamer.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/SignatureDecoder.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/YouTubeDownloader.php");
                                require_once(dirname(__FILE__) . "/res/youtube-dl/src/PlayerResponseParser.php");
                            }
                            try
                            {
                                $downloader = new YouTube\YouTubeDownloader();
                                $video = $downloader->getDownloadLinks('https://www.youtube.com/watch?v=' . $id);
                            }
                            catch(Exception $e)
                            {
                                mlsb_log_to_file('Exception thrown while downloading YouTube video: ' .  get_class($e) . ' - '  . $e->getMessage());
                                continue;
                            }
                            $za_vid = '';
                            if ($video->getAllFormats()) {
                                $vcombined = $video->getCombinedFormats();
                                if($vcombined != false)
                                {
                                    $vcount = count($vcombined);
                                    if($vcount > 0)
                                    {
                                        $za_vid = $vcombined[$vcount-1]->url;
                                    }
                                    else
                                    {
                                        $za_vid = $video->getFirstCombinedFormat()->url;
                                    }
                                }
                                else
                                {
                                    $za_vid = $video->getFirstCombinedFormat()->url;
                                }
                            }
                            if($za_vid != '')
                            {
                                if (isset($mlsb_Main_Settings['max_size']) && $mlsb_Main_Settings['max_size'] != '')
                                {
                                    $filesize = mlsb_retrieve_remote_file_size($za_vid);
                                    if($filesize !== false && $filesize != -1)
                                    {
                                        if($filesize > $mlsb_Main_Settings['max_size'] * 1024 * 1024)
                                        {
                                            continue;
                                        }
                                    }
                                    else
                                    {
                                        mlsb_log_to_file('Failed to get file size for: ' . $za_vid);
                                    }
                                }
                                $local_path = mlsb_upload_media_library($za_vid);
                                if($local_path !== false)
                                {
                                    $finals['xmlsb' . $id] = $local_path[1];
                                    $deletes[] = $local_path[1];
                                }
                            }
                        }
                    }
                    if(isset($mlsb_Youtube_Settings['vimeo_embedded']) && $mlsb_Youtube_Settings['vimeo_embedded'] == 'on')
                    {
                        preg_match_all('/https?:\/\/(?:www\.|player\.)?vimeo.com\/(?:channels\/(?:\w+\/)?|groups\/([^\/]*)\/videos\/|album\/(\d+)\/video\/|video\/|)(\d+)(?:$|\/|\?)?/', $lnk, $vimeos);
                        if(isset($vimeos[3][0]) && is_numeric($vimeos[3][0]))
                        {
                            $vimeourl = mlsb_getVimeoMP4($vimeos[3][0]);
                            if($vimeourl !== false && $vimeourl !== '')
                            {
                                if (isset($mlsb_Main_Settings['max_size']) && $mlsb_Main_Settings['max_size'] != '')
                                {
                                    $filesize = mlsb_retrieve_remote_file_size($vimeourl);
                                    if($filesize !== false && $filesize != -1)
                                    {
                                        if($filesize > $mlsb_Main_Settings['max_size'] * 1024 * 1024)
                                        {
                                            continue;
                                        }
                                    }
                                    else
                                    {
                                        mlsb_log_to_file('Failed to get file size for: ' . $vimeourl);
                                    }
                                }
                                $local_path = mlsb_upload_media_library($vimeourl);
                                if($local_path !== false)
                                {
                                    $finals[] = $local_path[1];
                                    $deletes[] = $local_path[1];
                                }
                            }
                        }
                    }
                    if(isset($mlsb_Youtube_Settings['dm_embedded']) && $mlsb_Youtube_Settings['dm_embedded'] == 'on')
                    {
                        preg_match_all('#https?:\/\/www.dailymotion.com\/video\/([^\s"\']*)#i', $lnk, $dms);
                        if(isset($dms[1][0]))
                        {
                            $dmurl = mlsb_getDMMP4($dms[1][0]);
                            if($dmurl !== false && $dmurl !== '')
                            {
                                if (isset($mlsb_Main_Settings['max_size']) && $mlsb_Main_Settings['max_size'] != '')
                                {
                                    $filesize = mlsb_retrieve_remote_file_size($dmurl);
                                    if($filesize !== false && $filesize != -1)
                                    {
                                        if($filesize > $mlsb_Main_Settings['max_size'] * 1024 * 1024)
                                        {
                                            continue;
                                        }
                                    }
                                    else
                                    {
                                        mlsb_log_to_file('Failed to get file size for: ' . $dmurl);
                                    }
                                }
                                $local_path = mlsb_upload_media_library($dmurl);
                                if($local_path !== false)
                                {
                                    $finals[] = $local_path[1];
                                    $deletes[] = $local_path[1];
                                }
                            }
                        }
                        else
                        {
                            preg_match_all('#https?:\/\/www.dailymotion.com\/embed\/video\/([^\s"\']*)#i', $lnk, $dms);
                            if(isset($dms[1][0]))
                            {
                                $dmurl = mlsb_getDMMP4($dms[1][0]);
                                if($dmurl !== false && $dmurl !== '')
                                {
                                    if (isset($mlsb_Main_Settings['max_size']) && $mlsb_Main_Settings['max_size'] != '')
                                    {
                                        $filesize = mlsb_retrieve_remote_file_size($dmurl);
                                        if($filesize !== false && $filesize != -1)
                                        {
                                            if($filesize > $mlsb_Main_Settings['max_size'] * 1024 * 1024)
                                            {
                                                continue;
                                            }
                                        }
                                        else
                                        {
                                            mlsb_log_to_file('Failed to get file size for: ' . $dmurl);
                                        }
                                    }
                                    $local_path = mlsb_upload_media_library($dmurl);
                                    if($local_path !== false)
                                    {
                                        $finals[] = $local_path[1];
                                        $deletes[] = $local_path[1];
                                    }
                                }
                            }
                        }
                    }
                    if(isset($mlsb_Youtube_Settings['fb_embedded']) && $mlsb_Youtube_Settings['fb_embedded'] == 'on')
                    {
                        preg_match_all('#https:\/\/www.facebook.com\/(.+?)\/videos\/([^\s\'"]+?)\/#i', $lnk, $dms);
                        if(isset($dms[0][0]))
                        {
                            $dmurl = mlsb_getFBMP4($dms[0][0]);
                            if($dmurl !== false && $dmurl !== '')
                            {
                                if (isset($mlsb_Main_Settings['max_size']) && $mlsb_Main_Settings['max_size'] != '')
                                {
                                    $filesize = mlsb_retrieve_remote_file_size($dmurl);
                                    if($filesize !== false && $filesize != -1)
                                    {
                                        if($filesize > $mlsb_Main_Settings['max_size'] * 1024 * 1024)
                                        {
                                            continue;
                                        }
                                    }
                                    else
                                    {
                                        mlsb_log_to_file('Failed to get file size for: ' . $dmurl);
                                    }
                                }
                                $local_path = mlsb_upload_media_library($dmurl);
                                if($local_path !== false)
                                {
                                    $finals[] = $local_path[1];
                                    $deletes[] = $local_path[1];
                                }
                            }
                        }
                        else
                        {
                            preg_match_all('#https:\/\/www\.facebook\.com\/plugins\/video\.php\?href=(.+?)&#i', $lnk, $dms);
                            if(isset($dms[1][0]))
                            {
                                $dmurl = mlsb_getFBMP4(urldecode($dms[1][0]));
                                if($dmurl !== false && $dmurl !== '')
                                {
                                    if (isset($mlsb_Main_Settings['max_size']) && $mlsb_Main_Settings['max_size'] != '')
                                    {
                                        $filesize = mlsb_retrieve_remote_file_size($dmurl);
                                        if($filesize !== false && $filesize != -1)
                                        {
                                            if($filesize > $mlsb_Main_Settings['max_size'] * 1024 * 1024)
                                            {
                                                continue;
                                            }
                                        }
                                        else
                                        {
                                            mlsb_log_to_file('Failed to get file size for: ' . $dmurl);
                                        }
                                    }
                                    $local_path = mlsb_upload_media_library($dmurl);
                                    if($local_path !== false)
                                    {
                                        $finals[] = $local_path[1];
                                        $deletes[] = $local_path[1];
                                    }
                                }
                            }
                            else
                            {
                                preg_match_all('#https:\/\/www\.facebook\.com\/(?:video\.php|watch)\/?\?v=(\d*)#i', $lnk, $dms);
                                
                                if(isset($dms[0][0]))
                                {
                                    $dmurl = mlsb_getFBMP4(urldecode($dms[0][0]));
                                    if($dmurl !== false && $dmurl !== '')
                                    {
                                        if (isset($mlsb_Main_Settings['max_size']) && $mlsb_Main_Settings['max_size'] != '')
                                        {
                                            $filesize = mlsb_retrieve_remote_file_size($dmurl);
                                            if($filesize !== false && $filesize != -1)
                                            {
                                                if($filesize > $mlsb_Main_Settings['max_size'] * 1024 * 1024)
                                                {
                                                    continue;
                                                }
                                            }
                                            else
                                            {
                                                mlsb_log_to_file('Failed to get file size for: ' . $dmurl);
                                            }
                                        }
                                        $local_path = mlsb_upload_media_library($dmurl);
                                        if($local_path !== false)
                                        {
                                            $finals[] = $local_path[1];
                                            $deletes[] = $local_path[1];
                                        }
                                    }
                                }
                            }
                        }
                    }
                    if(isset($mlsb_Youtube_Settings['tw_embedded']) && $mlsb_Youtube_Settings['tw_embedded'] == 'on')
                    {
                        preg_match_all('#https?:\/\/clips\.twitch\.tv\/([^\s\'"]*)#i', $lnk, $dms);
                        if(isset($dms[0][0]))
                        {
                            $dmurl = mlsb_getTWMP4($dms[0][0]);
                            if($dmurl !== false && $dmurl !== '')
                            {
                                if (isset($mlsb_Main_Settings['max_size']) && $mlsb_Main_Settings['max_size'] != '')
                                {
                                    $filesize = mlsb_retrieve_remote_file_size($dmurl);
                                    if($filesize !== false && $filesize != -1)
                                    {
                                        if($filesize > $mlsb_Main_Settings['max_size'] * 1024 * 1024)
                                        {
                                            continue;
                                        }
                                    }
                                    else
                                    {
                                        mlsb_log_to_file('Failed to get file size for: ' . $dmurl);
                                    }
                                }
                                $local_path = mlsb_upload_media_library($dmurl);
                                if($local_path !== false)
                                {
                                    $finals[] = $local_path[1];
                                    $deletes[] = $local_path[1];
                                }
                            }
                        }
                        else
                        {
                            preg_match_all('#<iframe(?:[^>]*?)src="https:\/\/clips.twitch.tv\/embed\?clip=([^"&\s\']*)"#i', $lnk, $dms);
                            if(isset($dms[1][0]))
                            {
                                $dmurl = mlsb_getTWMP4('https://clips.twitch.tv/embed?clip=' . $dms[1][0]);
                                if($dmurl !== false && $dmurl !== '')
                                {
                                    if (isset($mlsb_Main_Settings['max_size']) && $mlsb_Main_Settings['max_size'] != '')
                                    {
                                        $filesize = mlsb_retrieve_remote_file_size($dmurl);
                                        if($filesize !== false && $filesize != -1)
                                        {
                                            if($filesize > $mlsb_Main_Settings['max_size'] * 1024 * 1024)
                                            {
                                                continue;
                                            }
                                        }
                                        else
                                        {
                                            mlsb_log_to_file('Failed to get file size for: ' . $dmurl);
                                        }
                                    }
                                    $local_path = mlsb_upload_media_library($dmurl);
                                    if($local_path !== false)
                                    {
                                        $finals[] = $local_path[1];
                                        $deletes[] = $local_path[1];
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        break;
                    }
                }
            }
            
            if (isset($mlsb_Main_Settings['enable_detailed_logging']) && $mlsb_Main_Settings['enable_detailed_logging'] == 'on') 
            {
                mlsb_log_to_file('Found video URLs in post: ' . print_r($finals, true));
            }
            if(count($finals) == 0)
            {
                return;
            }
            $post_added = false;
            try
            {
                if (isset($mlsb_Main_Settings['max_at_once']) && $mlsb_Main_Settings['max_at_once'] != '')
                {
                    $max_at_once = $mlsb_Main_Settings['max_at_once']; 
                }
                else
                {
                    $max_at_once = 1; 
                }
                $video_number = 1;
                foreach($finals as $key => $videoPath)
                {
                    if($video_number > $max_at_once)
                    {
                        break;
                    }
                    //$videoPath = str_replace('%', '%25', $videoPath);
                    update_post_meta($post->ID, 'youtube_post_video_path', $videoPath);
                    $htmlBody = '';
                    {
                        $cdn_url = trim($mlsb_Youtube_Settings['server_url']);
                        $cdn_url = str_replace('{stream_key}', '', $cdn_url);
                        $cdn_url = trim($cdn_url, '/');
                        $cdn_url = $cdn_url . '/' . trim($mlsb_Youtube_Settings['server_key']);
                        
                        if (isset($mlsb_Main_Settings['ffmpeg_path']) && $mlsb_Main_Settings['ffmpeg_path'] != '')
                        {
                            $ffmpeg_comm = $mlsb_Main_Settings['ffmpeg_path'] . ' ';
                        }
                        else
                        {
                            $ffmpeg_comm = 'ffmpeg ';
                        }
                        if (isset($mlsb_Youtube_Settings['video_width']) && $mlsb_Youtube_Settings['video_width'] != '' && $mlsb_Youtube_Settings['video_width'] != 'default' && isset($mlsb_Youtube_Settings['video_height']) && $mlsb_Youtube_Settings['video_height'] != '' && $mlsb_Youtube_Settings['video_height'] != 'default') 
                        {
                            $vid_size = '-s ' . $mlsb_Youtube_Settings['video_width'] . 'x' . $mlsb_Youtube_Settings['video_height'];
                        }
                        else
                        {
                            $vid_size = '';
                        }
                        if (isset($mlsb_Youtube_Settings['frame_rate']) && $mlsb_Youtube_Settings['frame_rate'] != '') 
                        {
                            $frame_rate = $mlsb_Youtube_Settings['frame_rate'];
                        }
                        else
                        {
                            $frame_rate = '30';
                        }
                        $ffmpeg_comm .= '-re -i ' . $videoPath;
                        if($is_demo === '1')
                        {
                            $ffmpeg_comm .= ' -t 00:03:00';
                        }
                        if(isset($mlsb_Youtube_Settings['custom_params']) && $mlsb_Youtube_Settings['custom_params'] != '')
                        {
                            $ffmpeg_comm .=  $mlsb_Youtube_Settings['custom_params'];
                        }
                        else
                        {
                            $ffmpeg_comm .=  ' -codec:a aac  -ar 44100 -b:a 128k -pix_fmt yuv420p -profile:v baseline ' . esc_html($vid_size) . ' -bufsize 6000k -vb 2048k -strict -2 -vcodec libx264 -preset ultrafast -g 60 -r ' . $frame_rate . ' -loglevel error';
                        }
                        if(isset($mlsb_Youtube_Settings['max_bit_rate']) && $mlsb_Youtube_Settings['max_bit_rate'] != '')
                        {
                            $ffmpeg_comm .=  ' -maxrate ' . $mlsb_Youtube_Settings['max_bit_rate'];
                        }
                        else
                        {
                            $ffmpeg_comm .=  ' -maxrate 4500k';
                        }
                        if(isset($mlsb_Youtube_Settings['min_bit_rate']) && $mlsb_Youtube_Settings['min_bit_rate'] != '')
                        {
                            $ffmpeg_comm .=  ' -minrate ' . $mlsb_Youtube_Settings['min_bit_rate'];
                        }
                        else
                        {
                            $ffmpeg_comm .=  ' -minrate 3000k';
                        }
                        $ffmpeg_comm .=  ' -f flv "' . $cdn_url . '"';
                        if(isset($mlsb_Youtube_Settings['multi_stream']) && $mlsb_Youtube_Settings['multi_stream'] != '')
                        {
                            $stream_urls = preg_split('/\r\n|\r|\n/', trim($mlsb_Youtube_Settings['multi_stream']));
                            foreach($stream_urls as $surls)
                            {
                                if(trim($surls) != '')
                                {
                                    $ffmpeg_comm .=  ' -f flv "' . trim($surls) . '"';
                                }
                            }
                        }
                        $ffmpeg_comm .=  ' 2>&1';
                        if(isset($mlsb_Main_Settings['enable_detailed_logging']) && $mlsb_Main_Settings['enable_detailed_logging'] == 'on')
                        {
                            mlsb_log_to_file('Starting streaming for file ' . $videoPath . ' ffmpeg params: ' . $ffmpeg_comm);
                        }
                        if (isset($mlsb_Youtube_Settings['enable_conti']) && $mlsb_Youtube_Settings['enable_conti'] == 'on') {
                            $GLOBALS['wp_object_cache']->delete('mlsb_execstr', 'options');
                            $GLOBALS['wp_object_cache']->delete('mlsb_filename', 'options');
                            $mlsb_execstr = get_option('mlsb_execstr', false);
                            $mlsb_filename = get_option('mlsb_filename', false);
                            if(is_array($mlsb_execstr))
                            {
                                $mlsb_execstr[] = $ffmpeg_comm;
                            }
                            else
                            {
                                $mlsb_execstr = array($ffmpeg_comm);
                            }
                            if(is_array($mlsb_filename))
                            {
                                $mlsb_filename[] = $videoPath;
                            }
                            else
                            {
                                $mlsb_filename = array($videoPath);
                            }
                            if(count($mlsb_execstr) != count($mlsb_filename))
                            {
                                mlsb_log_to_file('Warning! mlsb_execstr count differs from mlsb_filename count. Please report this issue. ' . print_r($mlsb_execstr, true) . ' -- ' . print_r($mlsb_filename, true));
                            }
                            update_option('mlsb_execstr', $mlsb_execstr, false);
                            update_option('mlsb_filename', $mlsb_filename, false);
                        }
                        else
                        {
                            update_option('mlsb_execstr', $ffmpeg_comm, false);
                            update_option('mlsb_filename', $videoPath, false);
                        }
                        $unique_id = uniqid();
                        update_option('mlsb_uniqid', $unique_id);
                        $cron_url = site_url( '?mlsb_cronjob=1&mlsb_key=' . $unique_id);
                        wp_remote_post( $cron_url, array( 'timeout' => 0.1, 'blocking' => false, 'sslverify' => apply_filters( 'https_local_ssl_verify', true ) ) );
                        if($is_demo === '1')
                        {
                            update_option('mlsb_demo_last_time', time());
                        }
                        if(isset($mlsb_Main_Settings['enable_detailed_logging']) && $mlsb_Main_Settings['enable_detailed_logging'] == 'on')
                        {
                            mlsb_log_to_file('Streaming to live websites started: ' . $cron_url . ' - video path: ' . $videoPath . ' - ffmpegcomm: ' . $ffmpeg_comm);
                        }
                        $post_added = true;
                    } 
                    $video_number++;
                }
            }
            catch(Exception $e) 
            {
                foreach($finals as $dm)
                {
                    mlsb_log_to_file('Deleting (ex): ' . htmlspecialchars($dm));
                    if ($wp_filesystem->exists($dm)) {
                        $wp_filesystem->delete($dm);
                    }
                }
                mlsb_log_to_file('Exception thrown in live streaming website posting: ' . $e->getMessage());
            }
        }
    }
}

function mlsb_testFfmpeg()
{
    if(!function_exists('shell' . '_exec')) {
        return esc_html__('shell' . '_exec function is not enabled on your server! The plugin cannot run!', 'multilive-multiple-live-stream-broadcaster');
    }
    $disabled = explode(',', ini_get('disable_functions'));
    if(in_array('shell' . '_exec', $disabled))
    {
        return esc_html__('shell' . '_exec function is disabled by your hosting provider! The plugin cannot run!', 'multilive-multiple-live-stream-broadcaster');
    }
    $mlsb_Main_Settings = get_option('mlsb_Main_Settings', false);
    if (isset($mlsb_Main_Settings['ffmpeg_path']) && $mlsb_Main_Settings['ffmpeg_path'] != '') 
    {
        $ffmpeg_comm = $mlsb_Main_Settings['ffmpeg_path'] . ' ';
    }
    else
    {
        $ffmpeg_comm = 'ffmpeg ';
    }
    $shefunc = trim(' s ') . trim(' h ') . 'ell' . '_exec';
    $cmdResult = $shefunc($ffmpeg_comm . '-version');
    if($cmdResult === null)
    {
        $cmdResult = $shefunc($ffmpeg_comm . '-version 2>&1');
        if($cmdResult === null)
        {
            mlsb_log_to_file('Error in testFfmpeg: ' . $ffmpeg_comm . '-version 2>&1' . ' --- got: [NULL]');
            return 'null';
        }
        mlsb_log_to_file('Error in testFfmpeg: ' . $ffmpeg_comm . '-version 2>&1' . ' --- got: [' . $cmdResult . ']');
        return $cmdResult;
    }
    $analysis = mlsb_analyseResult($cmdResult, 'ffmpeg version');
    if($analysis == 1)
    {
        return 1;
    }
    return $cmdResult;
}

function mlsb_analyseResult($cmdResult, $testable)
{
    if (stristr($cmdResult, $testable) !== false) {
            return 1;
    }
    return 0;
}

function mlsb_is_json($string) {
 json_decode($string);
 return (json_last_error() == JSON_ERROR_NONE);
}

function mlsb_preg_grep_keys( $pattern, $input, $flags = 0 )
{
    $keys = preg_grep( $pattern, array_keys( $input ), $flags );
    $vals = array();
    foreach ( $keys as $key )
    {
        $vals[$key] = $input[$key];
    }
    return $vals;
}
function mlsb_generate_thumbmail( $post_id )
{    
    $post = get_post($post_id);
    $post_parent_id = $post->post_parent === 0 ? $post->ID : $post->post_parent;
    if ( has_post_thumbnail($post_parent_id) )
    {
        if ($id_attachment = get_post_thumbnail_id($post_parent_id)) {
            $the_image  = wp_get_attachment_url($id_attachment, false);
            return $the_image;
        }
    }
    $attachments = array_values(get_children(array(
        'post_parent' => $post_parent_id, 
        'post_status' => 'inherit', 
        'post_type' => 'attachment', 
        'post_mime_type' => 'image', 
        'order' => 'ASC', 
        'orderby' => 'menu_order ID') 
    ));
    if( sizeof($attachments) > 0 ) {
        $the_image  = wp_get_attachment_url($attachments[0]->ID, false);
        return $the_image;
    }
    $media = get_attached_media('image', $post_id);
    if( sizeof($media) > 0 ) {
        $the_image  = wp_get_attachment_url($media[0]->ID, false);
        return $the_image;
    }
    $image_url = mlsb_extractThumbnail($post->post_content);
    return $image_url;
}
function mlsb_extractThumbnail($content) {
    $att = mlsb_getUrls($content);
    if(count($att) > 0)
    {
        foreach($att as $link)
        {
            $mime = mlsb_get_mime($link);
            if(stristr($mime, "image/") !== FALSE){
                return $link;
            }
        }
    }
    else
    {
        return '';
    }
    return '';
}

function mlsb_add_admin_scripts( $hook ) {
    global $post;
    $mlsb_Youtube_Settings = get_option('mlsb_Youtube_Settings', false);
    if (isset($mlsb_Youtube_Settings['mlsb_posting']) && $mlsb_Youtube_Settings['mlsb_posting'] == 'on') 
    {
        if ( $hook == 'post-new.php') {
            wp_enqueue_script('mlsb-new-post', plugins_url('scripts/publish.js', __FILE__), array('jquery'), false, true);
            wp_register_style('mlsb-progress', plugins_url('styles/mlsb-progress.css', __FILE__), false, '1.0.0');
            wp_enqueue_style('mlsb-progress');
        }
    }
}
add_action( 'admin_enqueue_scripts', 'mlsb_add_admin_scripts', 10, 1 );

add_action( 'admin_notices', 'mlsb_admin_notice_success' );
function mlsb_admin_notice_success() {
    $mlsb_Main_Settings = get_option('mlsb_Main_Settings', false);
    if (isset($mlsb_Main_Settings['mlsb_enabled']) && $mlsb_Main_Settings['mlsb_enabled'] == 'on')
    {
        if (isset($mlsb_Main_Settings['mlsb_notice_enabled']) && $mlsb_Main_Settings['mlsb_notice_enabled'] == 'on')
        {
            if(strstr($_SERVER['REQUEST_URI'], 'wp-admin/post-new.php')) 
            {
?>
    <div id="notVisibleID" class="notice notice-success is-dismissible cr_none">
    <br/><div id="myProgress">
  <div id="myBar"></div>
</div>
        <p><?php esc_html_e( 'Please wait while MultiLive - Live Stream Broadcaster plugin uploads live videos to the live streaming websites! Please do not close this page while processing! You can disable this notice from MultiLive - Live Stream Broadcaster plugin\'s settings panel.', 'multilive-multiple-live-stream-broadcaster' ); ?></p>
    </div>
<?php
            }
        }
    }
    
}

function mlsb_retrieve_remote_file_size($url){
	 $mlsb_Main_Settings = get_option('mlsb_Main_Settings', false);
     $ch = curl_init($url);
	 if (isset($mlsb_Main_Settings['proxy_url']) && $mlsb_Main_Settings['proxy_url'] != '') {
			curl_setopt($ch, CURLOPT_PROXY, $mlsb_Main_Settings['proxy_url']);
			if (isset($mlsb_Main_Settings['proxy_auth']) && $mlsb_Main_Settings['proxy_auth'] != '') {
				curl_setopt($ch, CURLOPT_PROXYUSERPWD, $mlsb_Main_Settings['proxy_auth']);
			}
	 }
     curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
     curl_setopt($ch, CURLOPT_HEADER, TRUE);
     curl_setopt($ch, CURLOPT_NOBODY, TRUE);
     curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
     curl_setopt($ch, CURLOPT_TIMEOUT, 60);
     $data = curl_exec($ch);
     $size = curl_getinfo($ch, CURLINFO_CONTENT_LENGTH_DOWNLOAD);

     curl_close($ch);
     return $size;
}

register_activation_hook(__FILE__, 'mlsb_check_version');
function mlsb_check_version()
{
    if (!function_exists('curl_init')) {
        echo '<h3>'.esc_html__('Please enable curl PHP extension. Please contact your hosting provider\'s support to help you in this matter.', 'multilive-multiple-live-stream-broadcaster').'</h3>';
        die;
    }
    global $wp_version;
    if (!current_user_can('activate_plugins')) {
        echo '<p>' . esc_html__('You are not allowed to activate plugins!', 'multilive-multiple-live-stream-broadcaster') . '</p>';
        die;
    }
    $php_version_required = '5.4';
    $wp_version_required  = '2.7';
    
    if (version_compare(PHP_VERSION, $php_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(esc_html__('This plugin can not be activated because it requires a PHP version greater than %1$s. Please update your PHP version before you activate it.', 'multilive-multiple-live-stream-broadcaster'), $php_version_required) . '</p>';
        die;
    }
    
    if (version_compare($wp_version, $wp_version_required, '<')) {
        deactivate_plugins(basename(__FILE__));
        echo '<p>' . sprintf(esc_html__('This plugin can not be activated because it requires a WordPress version greater than %1$s. Please go to Dashboard -> Updates to get the latest version of WordPress.', 'multilive-multiple-live-stream-broadcaster'), $wp_version_required) . '</p>';
        die;
    }
}

function mlsb_register_mysettings()
{
    mlsb_cron_schedule();
    register_setting('mlsb_option_group', 'mlsb_Main_Settings');
    register_setting('mlsb_option_group2', 'mlsb_Youtube_Settings');
    if (is_multisite()) {
        if (!get_option('mlsb_Main_Settings')) {
            mlsb_activation_callback(TRUE);
        }
    }
}

function mlsb_admin_load_files()
{
    wp_register_style('mlsb-browser-style', plugins_url('styles/mlsb-browser.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('mlsb-browser-style');
    wp_enqueue_script('jquery');
    wp_enqueue_script('media-upload');
    wp_enqueue_script('thickbox');
    wp_enqueue_style('thickbox');
    wp_register_style('mlsb-custom-style', plugins_url('styles/coderevolution-style.css', __FILE__), false, '1.0.0');
    wp_enqueue_style('mlsb-custom-style');
}
?>